<?php
/*
#####################################
#  ShopOS: Shopping Cart Software.
#  Copyright (c) 2008-2010
#  http://www.shopos.ru
#  http://www.shoposs.com
#  Ver. 1.0.0
#####################################
*/

$os_action = array();
$os_action_tmp = array();
$os_rewrite_action = array();
$os_filter = array();

$os_action_plug = array();

function add_action($tag, $function_to_add, $priority = 10) 
{
	global $os_action;
	global $os_action_tmp;
	global $os_action_plug;

    global $p; //class plugins
		
	if (is_object($p))
	{
		 $p->info[ $p->name ][ $tag ][] = $function_to_add;
	}

	$os_action_plug [ $function_to_add ] = $p->name;
	
	$os_action[ $tag ][ $function_to_add ] = $priority;


	return true;
}

function add_button_send($value)
{
   return '<span class="button"><button type="submit" value="'.$value.'">'.$value.'</button></span>';
}

function add_button($tag, $name, $value = '')
{
   if (!empty($name) && !empty($tag))
   {
      switch ($tag)
      {
          case 'page':
	           return '<a class="button" href="'.FILENAME_PLUGINS_PAGE.'?page='.$name.'"><span>'.$value.'</span></a>';
		
	      break;
	  
	      case 'main_page':
	           return '<a class="button" href="'.FILENAME_PLUGINS_PAGE.'?main_page='.$name.'"><span>'.$value.'</span></a>';
	      break;
      }
   }
}

function add_lang($value_first, $value_second)
{
   global $LANG;
   global $lang_setting;
   
   $LANG[$value_first][$lang_setting['first_code']] = $value;
}

function add_lang_setting($first_code, $second_code)
{
 /*  global $lang_setting;
   $lang_setting = array();
   $lang_setting['first_code'] = $first_code;
   $lang_setting['second_code'] = $second_code;
  */
}

function __($name)
{
   global $LANG;
   
   if (isset( $LANG[$name] )) return $LANG[$name]; else return false;
}

function add_css($path = NULL, $type = 'text/css')
{
   global $css_array;
   
   if (isset($path))
   {
       $css_array[$path] = true;
	   $_SESSION['css_array'][$path] = true; 
   }   
}

function add_js($path = NULL, $type = 'text/javascript', $media = 'all')
{
   global $js_array;
   
   if (isset($path))
   {
       $js_array[$path] = true;
	   $_SESSION['js_array'] = $js_array;
   }   
}

function shopos_get_js()
{

   if (isset($_SESSION['js_array']))
   {
      ob_start();
      foreach ($_SESSION['js_array'] as $_js => $_val)
	  {
	     if (is_file(DIR_FS_CATALOG.$_js))
		 {
		     include(DIR_FS_CATALOG.$_js);
		 }
	  }
	  
	  $js_file = ob_get_contents();
	  ob_end_clean();
	  
	  return $js_file;
   }
}

function get_js_name()
{
   if (isset($_SESSION['js_array']) && !empty($_SESSION['js_array']))
   {
      $js_array = $_SESSION['js_array'];
      ksort($js_array);
      $_js_name = '';
	  $i=0;
      foreach ($js_array as $_js => $_val)
	  {
	     $_tmp_name = explode('/', $_js);
		 $_tmp_name = $_tmp_name[count($_tmp_name)-1];
		 if ($i == 0) $_js_name .= strtolower($_tmp_name); else $_js_name .= ','.strtolower($_tmp_name); 
		 $i++;
	  }

	  return $_js_name;
   }
}

function shopos_get_css()
{
	
   if (isset($_SESSION['$css_array']))
   {
      foreach ($_SESSION['$css_array'] as $_css => $_val)
	  {
	     if (is_file(DIR_FS_CATALOG.$_css))
		 {
		     $css_file .= file_get_contents($_css);
		 }
	  }
	  
	  return $css_file;
   }
}

function add_filter($tag, $function)
{
    global $os_filter;
	
	$os_filter[ $tag ][] = $function;
	
	return true;
}

function apply_filters ($tag, $value)
{
   global $os_filter;
   
   if (isset($os_filter[ $tag ]) && count($os_filter[ $tag ])>0)
   {
      foreach ($os_filter[ $tag ] as $_filter_func)
	  {
	     if (function_exists( $_filter_func ))
	     {
	           $value = $_filter_func ($value);
	     }
	  }
   }
   
   return $value;
}

function remove_action ($tag, $function_to_remove, $priority = 10)
{
	global $os_remove_action;
	
	$os_remove_action[$tag][$function_to_remove] = $priority; 
	
    return true;
}

function remove_action_array ()
{   
	global $os_remove_action;
	
	if (!empty($os_remove_action))
	{
        foreach ($os_remove_action as $tag => $functions_to_remove)
	    {
	         foreach ($functions_to_remove as $function_to_remove => $priority)
	         {
		          unset($os_remove_action[ $tag ][ $function_to_remove ]);  
	         }
	    }
    }
	else
    {  
	    // action.  
	   return false;
	}
	
    return true;
}

//  action  
function rewrite_action ($tag, $function, $function_to_add)
{   
    global $os_rewrite_action;
	
	$os_rewrite_action[ $tag ][ $function ] = $function_to_add;
	
	return true;
}

function plugurl()
{
   	global $p; //class plugins
		
    return http_path('catalog').$p->dir;
}

function plugdir()
{
   	global $p; //class plugins
	
   // $dir = _PLUG.dirname($p->name).'/';
	
	//$dir = str_replace('//', '/', $dir);
	//$dir = str_replace('\\\\', '\\', $dir);
	
	return get_path('catalog').$p->dir;
}

function run_action ($tag, $separator = '')
{
    global $os_action;
	global $os_action_plug;
	global $p;
	
	if (!empty($tag) && isset($os_action[$tag]))
	{
	    foreach ($os_action[$tag] as $_tag => $priority)
        {
              if (function_exists($_tag))
	          {
			        $p->name = $os_action_plug[$_tag];
					$p->group = $p->info[$p->name]['group'];
					//set dir
					$p->set_dir();
	                $_tag();
			        echo $separator;
              }
        }
	}
}

function output_action($tag, $separator = '')
{
    global $os_action;
	global $os_action_plug;
	global $p;
	
	ob_start();
	
	if (!empty($tag) && isset($os_action[$tag]))
	{
	    foreach ($os_action[$tag] as $_tag => $priority)
        {
              if (function_exists($_tag))
	          {
			        $p->name = $os_action_plug[$_tag];
					
	                $_tag();
			        echo $separator;
              }
        }
	}
	
	$m_content = ob_get_contents();
	ob_end_clean();
	
	return $m_content;
}

function is_action($tags)
{
    global $os_action;
  
    if (isset($os_action[$tags]))
    {
        return true;
    }
    else
    {
        return false;
    }
}

if (!function_exists('_e'))
{
   function _e ($text)
   {
	  echo $text."\n";
	  return true;
   }
}

?>